<template>
  <div class="projects-summary">
    <h3>Total overview:</h3>
    <div class="row">
      <div class="col col-4">
        <SummaryCard>
          <template #Header>No. of projects with due date in the past:</template>
          {{dueDateInPast}}
        </SummaryCard>
      </div>
      <div class="col col-4">
        <SummaryCard>
          <template #Header>Most prominent source language:</template>
          <span v-if="prominentSource">{{prominentSource.sourceLanguage}}</span>
        </SummaryCard>
      </div>
      <div class="col col-4">
        <SummaryCard>
          <template #Header>No. of projects by the status:</template>
          <div
            v-for="summary in noProjectsByStatus"
            :key="`projects-by-status-${summary.status}`"
          >
            <strong>{{summary.status}}:</strong> {{summary.total}}
          </div>
        </SummaryCard>
      </div>
    </div>
  </div>
</template>
<script lang="ts">
import _ from 'lodash';
import Vue from 'vue';
import { Component, Prop } from 'vue-property-decorator';
import { GridRow } from '@/components/grid/GridConfig';
import SummaryCard from './SummaryCard.vue';

@Component({
  components: {
    SummaryCard,
  },
})
export default class Summary extends Vue {
  @Prop({ required: true }) activeData!: Array<GridRow>

  get prominentSource() {
    return _.chain(this.activeData)
      .groupBy((item) => item.sourceLanguage)
      .map((item, sourceLanguage) => ({
        amount: item.length,
        sourceLanguage,
      }))
      .orderBy(['amount'], ['desc'])
      .head()
      .value();
  }

  get dueDateInPast() {
    return _.chain(this.activeData)
      .reduce((sum, project) => {
        const projectDueDate = new Date(project.dateDue);
        const now = new Date();

        return projectDueDate < now ? sum + 1 : sum;
      }, 0);
  }

  get noProjectsByStatus() {
    return _.chain(this.activeData)
      .groupBy((item) => item.status)
      .map((projects, status) => ({
        status,
        total: projects.length,
      }))
      .value();
  }
}
</script>
